//  Oꗗ\EBhE̕\
//
//		2006/02/26 JJWorkshop by HIRO.
//		v 1.00

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.PointerInfo;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.DefaultListModel;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import java.io.*;
import java.net.*;
import java.util.regex.*;
import java.util.Vector;
import java.awt.RenderingHints;

// -------------------------------------------------------------------------
// eudcStaticText		NX
// -------------------------------------------------------------------------
public class eudcCodeList extends eudcAppletBase 
{

	private EudcListFrame	lstFrame	= null;		// t[
	private boolean			isYomiList	= false;	// true=ǂ݈ꗗ false=Oꗗ
	private boolean			isLoad		= false;	// [hĂ
	private String			sTitle		= null;		// ^Cg 
	final	int				iIconSize	= 32;		// \ÕTCY
	final	int				iBgRGB		= 0x648AA6;	// Is̐F

	// CjVCY
	public void init() 
	{

		// eLXg̃X^Co
		try
		{
			isYomiList = (getParameter("MODE").toLowerCase().equals("yomi"));	
		}
		catch (NullPointerException e) {}
		sTitle = new String(isYomiList ? "ǂ݈ꗗ" : "Oꗗ");

		// {^쐬
		Button btn;
		add(btn = new Button(sTitle));
		btn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				ShowListWindow();
			}
		});
	}

	// CjVCY̏
	public void start()
	{
		// ʂ̏iT[o̐ݒj
		super.start();
		isLoad = true;
	}

	// ꗗ\̕\
	public void	ShowListWindow()
	{
		if (isLoad != true)		return;	// Avbg̏ĂȂ

		if (lstFrame == null)	
		{
			Point	pt = getLocationOnScreen();
			lstFrame = new EudcListFrame(sTitle);
			lstFrame.setLocationByPlatform(true);
			lstFrame.setLocation((int)pt.getX(),(int)pt.getY());

		}
		lstFrame.init();
	}


	// -------------------------------------------------------------------------
	// EudcListFrame		NX@iꗗEBhEj
	// -------------------------------------------------------------------------
	class EudcListFrame extends JFrame implements WindowListener,ItemListener 
	{

		private	Choice	combSelect			= null;	// O\̑IiR[hEǂ݁j
		private	JList	eudcList			= null;	// OXg
		private	DefaultListModel listModel	= null;	// JList̃Rg[f
		private JScrollPane scrollPane		= null;	// JList̃XN[yC
		
		private	int	iNowSelNo	= -1;	// ݂̑Iԍ	

		final	String	stYGyo[] = {"","","","","","Ă","Âł","Ȃɂʂ˂","͂Ђӂւ","΂тԂׂ","ς҂Ղ؂","܂݂ނ߂","",""};


		public EudcListFrame(String t)
		{
			// ACR̓ǂݍ
			Image image = Toolkit.getDefaultToolkit().createImage(getClass().getResource("icon.png"));
			// ACRZbg
			setIconImage(image);
			// LvVݒ
			setTitle(t);
		}

		public void init()
		{
			setVisible(true);
			if (eudcList != null)	return;		// 1x

			setBackground(Color.white);
			addWindowListener(this);


			// ̓Rg[QplECAEg쐬
			GridBagLayout gbl = new GridBagLayout();
			setLayout(gbl);
			GridBagConstraints gbc = new GridBagConstraints();
			gbc.anchor = GridBagConstraints.NORTHWEST;

			// IR{{bNX
			gbc.gridx = 0; gbc.gridy = 0;
			gbc.weightx = 1.0; gbc.weighty = 0.0;
			gbc.fill = GridBagConstraints.HORIZONTAL;
			gbc.anchor = GridBagConstraints.CENTER;
			combSelect = new Choice();
			combSelect.add("\OI");
			if (isYomiList)	
			{
				for (int i=0;i<stYGyo.length;i++)	
				{
					combSelect.add("u" + stYGyo[i].substring(0,1) + "vs̓ǂ");
				}
			}
			else
			{
				for (int i=0xe0;i<=0xf8;i++)	
				{
					String sCode = Integer.toHexString(i).toUpperCase();
					combSelect.add("R[hF" + sCode + "00 ` " + sCode + "FF ܂");
				}
			}
			combSelect.addItemListener(this);
			gbl.setConstraints(combSelect, gbc);
			add(combSelect);

			// OXg
			gbc.gridx = 0; gbc.gridy = 1;
			gbc.weightx = 0.0; gbc.weighty = 1.0;
			gbc.fill = GridBagConstraints.BOTH;
			gbc.anchor = GridBagConstraints.CENTER;
			listModel	= new DefaultListModel();
			eudcList	= new JList(listModel);
			EudcCellRenderer renderer = new EudcCellRenderer();
			eudcList.setCellRenderer(renderer);
			scrollPane	= new JScrollPane();
			scrollPane.getViewport().setView(eudcList);
			gbl.setConstraints(scrollPane, gbc);
			add(scrollPane);

			// EBhETCY
			setSize(200,400);
		}


		// R{̑I
		public void itemStateChanged(ItemEvent e) 
		{
			int iSelNo = combSelect.getSelectedIndex();
			if (iSelNo == iNowSelNo)	return;	// I͖

			// Xg̔j
			listModel.clear();
			// eXg̍쐬
			if (iSelNo < 1)	return;	
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			if (isYomiList)
			{
				listChangeYomi(iSelNo-1);
			}
			else
			{
				listChangeCode(iSelNo-1);
			}
			iNowSelNo = iSelNo;
			setCursor(Cursor.getDefaultCursor());
		}

		// R[hꗗXg쐬
		private void listChangeCode(int iYGyoNo) 
		{
			// O₢킹̑gݗ
			StringBuffer  sbText = new StringBuffer(256);
			int	iEudcHex = 0;
			for (int i=0;i<=0xff;i++)	
			{
				iEudcHex = 0xe000 + iYGyoNo * 0x100 + i;
				char ch[] = {(char)iEudcHex};
				sbText.append(ch);
			}
			// wR[h́AOC[WT[oɖ₢킹
			String stEudcText =	ChangeEudcText(sbText.toString());
			if (stEudcText != null)	
			{
				// o͕f[^o
				try
				{
					String	stDatas[]  = stEudcText.split(" ");
					for (int j=0;j<stDatas.length;j++)
					{
						if (stDatas[j].length() > 7)	
						{	// xxxxx:0 f[^
							listModel.addElement(stDatas[j]);
						}
					}
				}
				catch (NullPointerException e) {}
			}
		}

		// ǂ݈ꗗXg쐬
		private void listChangeYomi(int iYCodeNoSeq) 
		{
			String	stGyo		= stYGyo[iYCodeNoSeq];
			String	stYomiEudc	= null;
			for (int i=0;i<stGyo.length();i++)
			{
				stYomiEudc = YomiEudcText(stGyo.substring(i,i+1));
				if (stYomiEudc != null && stYomiEudc.length() > 6)	// Pꍇ͋󔒂P	
				{
					try
					{
						String	stDatas[]  = stYomiEudc.split(" ");
						for (int j=0;j<stDatas.length;j++)
						{
							if (j == 0)	
							{
								listModel.addElement("u" + stGyo.substring(i,i+1) + "vn܂ǂ");
							}
							listModel.addElement(stDatas[j]);
						}
					}
					catch (NullPointerException ex) {}
				}
			}
		}

		public void windowIconified(WindowEvent e){}	// ACRꂽƂĂ΂
		public void windowDeiconified(WindowEvent e){}	// ACR߂ƂĂ΂
    
		public void windowActivated(WindowEvent e){}	// EChEANeBuɂȂƂ
		public void windowDeactivated(WindowEvent e){}	// EChEANeBuŖȂƂ
		public void windowOpened(WindowEvent e){}		// EChEJꂽƂ
		public void windowClosing(WindowEvent e)
		{
			// EChE悤ƂĂƂ
			setVisible(false);
			dispose();
		}
		public void windowClosed(WindowEvent e){}		// EChEꂽ
    
	}

	// -------------------------------------------------------------------------
	// EudcCellRenderer		NX@iZ̍揈j
	// -------------------------------------------------------------------------
	class EudcCellRenderer extends JLabel implements ListCellRenderer 
	{
		public EudcCellRenderer() 
		{
			setOpaque(true);
		}

		public Component getListCellRendererComponent(
			JList list,
			Object value,
			int index,
			boolean isSelected,
			boolean cellHasFocus)
		{
			// ÕR[h\
			String	stExcDatas[]  = value.toString().split(":");// [0]͊OUnicode10i
			if (stExcDatas.length != 4)	
			{
				// Of[^ł͂Ȃi^Cgj
				setText(value.toString());
				setBackground(Color.white);
				setForeground(Color.blue);
				setIcon(null);
			}
			else	
			{
				// OR[h̕PUi
				setText("@@"+Integer.toHexString(Integer.valueOf(stExcDatas[0])).toUpperCase());
				setBackground(isSelected ? new Color(iBgRGB) : Color.white);
				setForeground(isSelected ? Color.white : Color.black);
				// OC[W
				int	sizeX = Integer.parseInt(stExcDatas[1]) / 8;	// 1byte/8bit
				int	sizeY = Integer.parseInt(stExcDatas[2]);
				BufferedImage	image = new BufferedImage(sizeX*8,sizeY,BufferedImage.TYPE_3BYTE_BGR);
				Graphics	g2 = image.getGraphics();
				g2.setColor(Color.white);
				g2.fillRect(0,0,sizeX*8,sizeY);
				int h,tb,cnt=0;
				int xx = 0;
				for (int j=0;j<sizeY;j++)	
				{
					xx = 0;
					for (int i=0;i<sizeX;i++)	
					{
						try	
						{
							tb = 0x80;
							h  = 0xff & ~Integer.parseInt(stExcDatas[3].substring(cnt,cnt+2),16);
							for (int k=0;k<8;k++)
							{
								if ((tb & h) != 0)	
								{
									image.setRGB(xx,j,0x000000);
								}
								tb >>>=1;
								xx++;
							}
						}
						catch (NumberFormatException e) {}
						cnt = cnt + 2;
					}
				}
				setIcon(new ImageIcon(image.getScaledInstance(iIconSize,-1,Image.SCALE_SMOOTH)));
			}

			return this;
		}
	}
}
