//  O܂ތŒ蕶\
//
//		2005/12/27 JJWorkshop by HIRO.
//		v 1.01

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.util.regex.*;
import java.awt.RenderingHints;

// -------------------------------------------------------------------------
// eudcStaticText		NX
// -------------------------------------------------------------------------
public class eudcStaticText extends eudcAppletBase 
{

	private String	stSrcText	= null;		// \eLXg
	private	String	sFontName	= "serif";	// \̃tHg
	private int		iTextSize	= 12;		// \tHg̃TCY
	private int		iAdjustY	= 0;		// Ȍ㉺ʒu𒲐
	private int		iTextRGB	= 0;		// eLXgJ[
	private int		iBgRGB		= 0xffffff;	// obNOEhJ[
	private int		iTextAlign	= 0;		// 0=left , 1=right  , 2=center
	private int		iTextVAlign	= 0;		// 0=top  , 1=bottom , 2=center
	private int		iTextPadding= 0;		// eLXg̍E㉺pfBO

	// CjVCY
	public void init() 
	{
		try
		{
			// eLXg̃X^Co
			String	stStyle[] = getParameter("STL").toLowerCase().split(",");
			for (int i=0;i<stStyle.length;i++)
			{
				String	stParam[] = stStyle[i].replaceAll(" ","").split("=");
				if (stParam.length == 2)
				{
					if (stParam[0].equals("size"))
					{
						iTextSize = Integer.parseInt(stParam[1]);
					}
					else if (stParam[0].equals("adjust"))
					{
						iAdjustY = Integer.parseInt(stParam[1]);
					}
					else if (stParam[0].equals("color"))
					{
						iTextRGB = Integer.parseInt(stParam[1],16);
					}
					else if (stParam[0].equals("bgcolor"))
					{
						iBgRGB = Integer.parseInt(stParam[1],16);
					}
					else if (stParam[0].equals("fontname"))
					{
						sFontName = stParam[1];
					}
					else if (stParam[0].equals("align"))
					{
						if (stParam[1].equals("right"))
						{
							iTextAlign = 1;
						}
						else if (stParam[1].equals("center"))
						{
							iTextAlign = 2;
						}
					}
					else if (stParam[0].equals("valign"))
					{
						if (stParam[1].equals("bottom"))
						{
							iTextVAlign = 1;
						}
						else if (stParam[1].equals("center"))
						{
							iTextVAlign = 2;
						}
					}
					else if (stParam[0].equals("padding"))
					{
						iTextPadding = Integer.parseInt(stParam[1]);
					}
				}
			}
		}
		catch (NullPointerException e) {}

	}

	// CjVCY̏
	public void start()
	{
		// ʂ̏iT[o̐ݒj
		super.start();

		// T[oɖ₢킹ďo͕f[^擾
		try
		{
			stSrcText = ChangeEudcText(getParameter("STR"));
		}
		catch (NullPointerException e) {}
	}

	// O܂ޕ
	public void paint(Graphics g) 
	{
		Dimension dim = getSize();
		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);

		// tHgݒ
		g2.setFont(new Font(sFontName,Font.PLAIN,iTextSize));

		// tHggbN擾
		FontMetrics	fm = g2.getFontMetrics();

		// O̕vZ
		int  iExWidth = 0;
		{
			char ch[] = {'',0x0};	// 擾Ɂur̉_[02500]gpv
			iExWidth = fm.charWidth(ch[0]);
		}

		// wiݒ
		g2.setColor(new Color(iBgRGB));
		g2.fillRect(0,0,dim.width,dim.height);

		// J[ݒ
		g2.setColor(new Color(iTextRGB));

		// o͕f[^o
		String	stDatas[]  = null;
		try
		{
			stDatas = stSrcText.split(" ");
		}
		catch (NullPointerException e){}

		// vZ
		int	iTextWidth = 0;
		for (int i=0;stDatas != null && i<stDatas.length;i++)	
		{
			if (stDatas[i].length() >= 6)
			{
				// oCi[f[^
				iTextWidth += iExWidth;
			}
			else	
			{
				// LN^f[^
				char ch[] = {(char)Integer.parseInt(stDatas[i]),0x0};
				iTextWidth += fm.charWidth(ch[0]);
			}
		}

		// ʒuvZ
		int x = iTextPadding;	// left
		switch (iTextAlign)
		{
			case 1:				// right
				x = dim.width - (iTextWidth + iTextPadding);
				break;
			case 2:				// center
				x = (dim.width - iTextWidth) / 2;
				break;
		}
		int y =	iTextPadding + fm.getHeight();	// top
		switch (iTextVAlign)
		{
			case 1:				// bottom
				y = dim.height - iTextPadding - fm.getDescent();
				break;
			case 2:				// center
				y = (dim.height + fm.getHeight()) / 2;
				break;
		}

		// o͕f[^
		for (int i=0;stDatas != null && i<stDatas.length;i++)	
		{
			if (stDatas[i].length() >= 6)
			{
				// oCi[f[^
				drawEudcChar(g2,x,y,iExWidth,fm,stDatas[i]);
				x += iExWidth;
			}
			else	
			{
				// LN^f[^
				char ch[] = {(char)Integer.parseInt(stDatas[i]),0x0};
				g2.drawChars(ch,0,1,x,y);
				x += fm.charWidth(ch[0]);
			}
		}
	}

	// O
	private void drawEudcChar(Graphics g,int x,int y,int width,FontMetrics fm,String buff)
	{
		// o͊Of[^o
		String	stExcDatas[]  = buff.split(":");	// [0]͊OUnicode10i
		if (stExcDatas.length != 4)	return;			// ԕ

		int	sizeX = Integer.parseInt(stExcDatas[1]) / 8;	// 1byte/8bit
		int	sizeY = Integer.parseInt(stExcDatas[2]);
		
		BufferedImage image = new BufferedImage(sizeX*8,sizeY,BufferedImage.TYPE_3BYTE_BGR);
		Graphics g2 = image.getGraphics();
		g2.setColor(new Color(iBgRGB));
		g2.fillRect(0,0,sizeX*8,sizeY);

		int h,tb,cnt=0;
		int xx = 0;
		for (int j=0;j<sizeY;j++)	
		{
			xx = 0;
			for (int i=0;i<sizeX;i++)	
			{
				try	
				{
					tb = 0x80;
					h  = 0xff & ~Integer.parseInt(stExcDatas[3].substring(cnt,cnt+2),16);
					for (int k=0;k<8;k++)
					{
						if ((tb & h) != 0)	
						{
							image.setRGB(xx,j,iTextRGB);
						}
						tb >>>=1;
						xx++;
					}
				}
				catch (NumberFormatException e) {}
				cnt = cnt + 2;
			}
		}
		Image siImg = image.getScaledInstance(width,-1,Image.SCALE_SMOOTH);
		g.drawImage(siImg,x,y-fm.getAscent()+fm.getDescent()/2+1+iAdjustY,null);

	}
}
